/* TRHelpBrowser.cc
   jan 1997
   Thomas Regner
   methods of TRHelpBrowser
   */
#include "TRHelpBrowser.h"
#include <iostream.h>
#include <stdlib.h>
#include "TRHelplink.h"

TRHelpBrowser::TRHelpBrowser() : FormApp() {
	fd_TRHelpForm = create_form_TRHelpForm();
	// It is very important here to save the this pointer
	// into the FL_FORM struct because we will need this
	// pointer in the callback the this pointer is saved
	// in the FormSetup method of the base class
	FormSetup();
    fl_set_pixmap_file( fd_TRHelpForm->TRHelpPixmap, "TRHelp.xpm");
    fl_set_browser_fontsize(fd_TRHelpForm->TRHelpBrowser, 14);
	n = 0;
}

TRHelpBrowser::~TRHelpBrowser() {
	// hide the form
	fl_hide_form(fd_TRHelpForm->TRHelpForm);
	// Free the form and the memory for the fd_TRHelpFormstruct
	fl_free_form(fd_TRHelpForm->TRHelpForm);
	fl_free(fd_TRHelpForm);
}

TRHelpBrowser *
TRHelpBrowser::GetThis(FL_OBJECT *obj) {
	return (TRHelpBrowser*) obj->form->u_vdata; 
}


void TRHelpBrowser::_TRHelpBrowserCallback(FL_OBJECT *obj, long
                                                  arg)
{
	// getting a "this" pointer
	TRHelpBrowser *me = GetThis(obj); 
	switch( arg)
    {
        case Quit:
            me->TRHelpQuit();
            break;
       case Browser:
            me->TRHelpFollowLink();
            break;
    }
    
}

void TRHelpBrowser::SetFile( const char* file)
{
    FL_OBJECT *browser=fd_TRHelpForm->TRHelpBrowser;
    fl_load_browser( browser, file);
}

void TRHelpBrowser::TRHelpQuit()
{
    Hide();
#if 0
    fl_free_form(fd_TRHelpForm->TRHelpForm);
    fl_free(fd_TRHelpForm);
    exit(0);
#endif
}

void TRHelpBrowser::TRHelpFollowLink()
{
    FL_OBJECT *browser=fd_TRHelpForm->TRHelpBrowser;
    int line = fl_get_browser( browser);
    int tline = -1;
    int i = 0;
    while( TRHlinks[i][0] != -1)
    {
        if( (TRHlinks[i][0]) == line)
        {
            tline = TRHlinks[i][1];
            exit;
        }
        i++;
    }
    if( tline != -1)
        fl_set_browser_topline( browser, tline);
}



// This is a good strategy for retrieving which object triggered
// a callback. Take a close look at the argument entered in the
// fdesign program
// With this strategy, you can have just one static callback
// and a switch to your methods



// This is the overloaded virtual method declared in FormApp
FL_FORM *
TRHelpBrowser::Form() {
	return fd_TRHelpForm->TRHelpForm;
}









