#include "TRHelpBuilder.h"
#include <fstream.h>

int main( int argc, char** argv)
{
    if( ( argc < 4) || ( argc > 5))
    {
        cout << endl << "Usage:" << endl <<
            "trhelp [-v] <inputfile> <outputfile> <includeoutputfile> " << endl;
    }

    TRHelpBuilder builder;
    int k = 1;
    if(argc == 5)
    {
        builder.SetVerboseFlag( TRUE);
        k = 2;
    }
    
    ifstream input;
    ofstream output;
    ofstream locfile;
    
    input.open(argv[k]);
    output.open(argv[k+1]);
    locfile.open(argv[k+2]);

    if(k == 2)
    {
        cout << "TRHelp V1.0 " << endl <<
            "Processing File " << argv[k] << endl;
        cout << "Forms Text File output to: " << argv[k+1] << endl;
        cout << "Include File output to: " << argv[k+2] << endl;
    }
    
    char text[30];
    if( ! builder.BuildTargetFile( input))
    {
        builder.GetErrorText( text);
        cerr << text;
        return 1;
    }
    
    if( ! builder.BuildLocFile( output, locfile))
    {
        builder.GetErrorText( text);
        cerr << text;
        return 1;
    }
    return 0;
}
